/*
 * CommunitiesListener.java
 *
 * Created on 25 de agosto de 2004, 15:24
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.User;
import com.fenalco.entities.PaymentMethodList;
import com.fenalco.utilities.MessageBuilder;

/**
 * Este servlet procesa las solicitudes del usuario representadas en el
 * parámetro operationType que define el tipo de operación que se realiza sobre
 * las comunidades del proveedor.
 * 
 * @author Mario Linares Vásquez
 *  
 */
public class CommunitiesListener extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 * @throws ServletException
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Método destructor.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa solicitudes para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>. Recibe de la página comunidades.jsp los parámetros
	 * <CODE>operationType</CODE> y <CODE>communityId</CODE>. De acuerdo
	 * con el valor de operationType realiza lo siguiente : - operationType =
	 * new redirecciona el flujo a nuevacomunidad.jsp - operationType = delete
	 * redirecciona el flujo al servlet administrarcomunidades con communityId
	 * como parámetro - operationType = view redirecciona el flujo al servlet
	 * comunidad con communityId como parámetro
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		String operationType = request.getParameter("operationType");
		String url = "";
		String message = "";
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				if( operationType.equals("add") )
				{
					//Nueva Comunidad
					url = "/proveedor/nuevacomunidad.jsp";
                                        int supplierId = ( ( User )request.getSession().getAttribute( "user" ) ).getCompanyId() ;
                                        PaymentMethodList list = new PaymentMethodList( supplierId );
                                        
                                        request.setAttribute( "list", list );
				}
				else
					if( operationType.equals("delete") )
					{
						//Eliminar Comunidad
						url = "/proveedor/administrarcomunidades";
						request.setAttribute("operationType", "delete");
					}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Procesa el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Procesa el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción de el servlet.
	 * 
	 * @return
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}